using JetBrains.Annotations;

namespace Robotless.Modules.Annotations;

/// <summary>
/// The types or type arguments marked with this attribute will be instantiated dynamically.
/// </summary>
[AttributeUsage(AttributeTargets.Parameter | AttributeTargets.GenericParameter | 
                AttributeTargets.Class | AttributeTargets.Struct | AttributeTargets.Interface),
 MeansImplicitUse(ImplicitUseKindFlags.InstantiatedWithFixedConstructorSignature)]
public class DynamicallyInstantiatedAttribute : Attribute
{}